﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using C1.Win.C1TrueDBGrid;

namespace CopyPasteRow_C1TrueDbGrid
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }
        private void Form1_Load(object sender, EventArgs e)
        {
            // Creating DataTable
            DataTable dataTable = new DataTable();

            // Add columns to the data table
            dataTable.Columns.Add("FirstName", typeof(string));
            dataTable.Columns.Add("LastName", typeof(string));
            dataTable.Columns.Add("Country", typeof(string));

            // Add rows to the data table
            dataTable.Rows.Add("Benjamin", "Jane", "United States");
            dataTable.Rows.Add("Grace", "Greg", "Japan");
            dataTable.Rows.Add("Seether", "Franklin", "Africa");
            dataTable.Rows.Add("Alex", "Daniels", "United Kingdom");
            dataTable.Rows.Add("Sean", "Chancey", "Australia");

            // Setting the datasource to C1TrueDbGrid
            c1TrueDBGrid1.SetDataBinding(dataTable, "");
            c1TrueDBGrid1.AllowAddNew = true;
            c1TrueDBGrid1.KeyDown += new KeyEventHandler(c1TrueDBGrid1_KeyDown);
        }

        void c1TrueDBGrid1_KeyDown(object sender, KeyEventArgs e)
        {
            string strTemp = null;
            // Code to copy the entire row
            if (e.KeyCode == Keys.C && e.Control)
            {
                if (this.c1TrueDBGrid1.SelectedRows.Count > 0)
                {
                    foreach (int rowloop in this.c1TrueDBGrid1.SelectedRows)
                    {
                        foreach (C1DataColumn col1 in this.c1TrueDBGrid1.Columns)
                        {
                            strTemp = strTemp + col1.CellText(rowloop) + "\t";
                        }
                        strTemp = strTemp + "\n";
                    }
                    // Sets the text in clipboard
                    System.Windows.Forms.Clipboard.SetDataObject(strTemp, true);
                }
            }

            // Code to paste entire row
            else if (e.KeyCode == Keys.V && e.Control)
            {
                char[] rowSplitter = { '\r', '\n' };
                char[] columnSplitter = { '\t' };

                // If it is the newly added row then allowing the user to edit it
                if (c1TrueDBGrid1.AddNewMode == AddNewModeEnum.AddNewCurrent)
                    c1TrueDBGrid1.EditActive = true;

                // Gets the text from clipboard and sets it in each cell accordingly
                IDataObject dataInClipboard = Clipboard.GetDataObject();
                string stringInClipboard = (string)dataInClipboard.GetData(DataFormats.Text);
                string[] rowsInClipboard = stringInClipboard.Split(rowSplitter, StringSplitOptions.RemoveEmptyEntries);

                for (int iRow = 0; iRow < rowsInClipboard.Length; iRow++)
                {
                    string[] valuesInRow = rowsInClipboard[iRow].Split(columnSplitter);
                    for (int iCol = 0; iCol < valuesInRow.Length - 1; iCol++)
                    {
                        c1TrueDBGrid1[c1TrueDBGrid1.Row, iCol] = valuesInRow[iCol];
                    }
                }
            }
            // Since we need to handle key down event manually, hence we need to set it to true
            e.SuppressKeyPress = true; // To prevent the default key press handling here
        }
    }
}
